---
id: ravenpage
title: "What is Raven?"
sidebar_label: "Raven Explained"
slug: /ravenpage
---





--------------------------

For the purpose of the project, it is important to understand the main product of the company, Raven.
This is because the product itself is a security tool, and the appeal of this project is creating the infrastructure that is
behind a security tool. Therefore, understanding what the security tool is meant to do is helpful in understanding why some of
the topics where researched and why specific decisions were made in certain areas.

DTACT Raven, or Raven for short is a powerful data streaming platform with a modular framework. What this means it is
a tool used to process, analyze and send data from different platforms much like a SOC system or for creating automated
[alerting systems](../../portofolio/glossary#alerting-systems] on different data systems. Some of the current use cases for the application are [Anti-phishing](https://dtact.com/use-cases/anti-phishing/), 
[SOC/SIEM](https://dtact.com/use-cases/soc-siem/), [Cloud Security Monitoring](https://dtact.com/use-cases/cloud-security-monitoring/). 


This all sounds very interesting but it is quite hard to visualize so to better understand the product and how it is used it
is helpful to visualize the platform itself. While this is a commercial product, the development environment has been made available for the
scope of the project.


![img](../../static/img/DTACTRanven.png)

#### Figure 1 – Starting page
---------------------------

As you can see this is the product itself, or rather the first page gives information about the events that are incoming
this month (which are down due to a recent redeploy), information of the different flows and the amount of data that is coming through each flow are going to be explained in a
second.

![img](../../static/img/DTACTRanvenFlow.png)

#### Figure 2 – Flow page
---------------------------

As seen in figure 2 there are various flows of data that contain different workers or bricks, brick are the
basic building block that get chained into a pipeline structure called a flow, each brick with a specific purpose.

Each flow represents a specific use case, some can be used for web crawling, some can be used for detecting assets in an
environment, or for anything that involves getting data from a certain source and then further analyzing it and adding actions
onto it, such as IP scans, geolocation, specific data breakdowns or transformations.


![img](../../static/img/RavenFlowDetailed.png)

#### Figure 3 – Detailed flow
---------------------------

 This process is better illustrated in figure 3. There are 3 sources that start 3 streams of data which are linked with actions
 bricks that are given specific actions such as transforming the data to a elasticsearch common schema, aggregating the source
 hosts from the 3 sources and then checking if the assets that are being managed exist in the data. And based on the check,
 action bricks are created for making tickets and alerts. Of course this is a simple example of what can be achieved, but with
 this a security analyst can easily create his own flows of data where he combines many sources and he can easily analyze the data.

![img](../../static/img/DTACTRanvenBrick.png)

#### Figure 4 – Brick creation
---------------------------

On top of the custom sources, users can create their own sources and bricks based on a
collection of premade templates. All of these templates can be used to suit the users needs for the flow they envision.

![img](../../static/img/DTACTRavenAnalyzer.png)

#### Figure 5 – Analyzer
---------------------------

On top of the main flow functionality all created sources can be monitored though the analyzer system, while in this
example the data is not present due to the recent redeploy, normally you could visualize different metrics about the data based
on the indices of the data.

![img](../../static/img/DTACTRavenQueries.png)

#### Figure 6 – Queries 
---------------------------

Based on the indices, queries can be made to further analyze the data for insights and to view it faster by using the
Lucene querying syntax. And as it can be seen in the picture useful queries can be saved for later use, such as seeing the
number of hosts for a source, the amount of certain data points or maybe the increase of emails sent by a certain IP at certain hours.

Overall Raven is a multipurpose tool that deals with processing, analyzing and guiding data through its system.
As such, the inner working of the application have to take into consideration all of this. Deploying Raven into an environment
has multiple layers of protection for data, the credentials for deploying the necessary components and the communication of
those components between each other.

As such, this project tackles these issues through research, and indentifies Ravens potential security and development issues 
that can occur at each point of the provisioning project to Azure. These aspects are better explored in the [Sprint 2](./sprint2).

For more information on the tool go visit the documentation pages of the application on https://docs.dtact.com/.

###  Conclusion
---------------------------

Raven is a data processing tool that can be used to create your own security, data enhancement or [alerting systems](../../portofolio/glossary#alerting-systems)
“actions” through flows. 
